]> git.ozlabs.org Git - yaboot.git/blob - ybin/yabootconfig
f343a7dad1f3ba74f9894bbac5849b6f2c14d4fc
[yaboot.git] / ybin / yabootconfig
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## yabootconfig generates a simple /etc/yaboot.conf
6 ## Copyright (C) 2001, 2002, 2003 Ethan Benson
7 ##
8 ## This program is free software; you can redistribute it and/or
9 ## modify it under the terms of the GNU General Public License
10 ## as published by the Free Software Foundation; either version 2
11 ## of the License, or (at your option) any later version.
12 ##
13 ## This program is distributed in the hope that it will be useful,
14 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
15 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 ## GNU General Public License for more details.
17 ##
18 ## You should have received a copy of the GNU General Public License
19 ## along with this program; if not, write to the Free Software
20 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
21 ##
22 ###############################################################################
23
24 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
25 ## allow to run out of /target in boot-floppies
26 if [ -n "$PATH_PREFIX" ] ; then
27     PATH="${PATH}:${PATH_PREFIX}/sbin:${PATH_PREFIX}/bin:${PATH_PREFIX}/usr/sbin:${PATH_PREFIX}/usr/bin:${PATH_PREFIX}/usr/local/sbin:${PATH_PREFIX}/usr/local/bin"
28 fi
29 PRG="${0##*/}"
30 VERSION=1.0.8-UNSUPPORTED_UNRELEASED_DEVEL
31 CHROOT=/
32 ## $CONFIG is relative to $CHROOT
33 CONFIG=etc/yaboot.conf
34 NOINSTALL=0
35 QUIET=0
36 DEBUG=0
37 SIGINT="$PRG: Interrupt caught ... exiting"
38 export LC_COLLATE=C
39
40 ## avoid older versions of ofpath shipped in debian boot-floppies etc.
41 if [ -x "${PATH_PREFIX}/usr/sbin/ofpath" ] ; then
42     OFPATH="${PATH_PREFIX}/usr/sbin/ofpath"
43 else
44     OFPATH=ofpath
45 fi
46
47 ## catch signals, clean up temporary file
48 trap "cleanup" 0
49 trap "exit 129" 1
50 trap "echo 1>&2 $SIGINT ; exit 130" 2
51 trap "exit 131" 3
52 trap "exit 143" 15
53
54 ## check for printf, use it if possible otherwise fall back on
55 ## unreliable echo -e -n ("SUS" says echo shall support no switches)
56 if [ "$(printf printf_test 2>/dev/null)" = printf_test ] ; then
57     PRINTF=printf
58 else
59     PRINTF="echo -e -n"
60 fi
61
62 ## make sure echo is not lame if we must use it.
63 if [ "$PRINTF" != printf ] ; then
64     if [ "$(echo -e -n echo_test)" != "echo_test" ] ; then
65         echo 1>&2 "$PRG: printf unavailable and echo is broken, sorry."
66         exit 1
67     fi
68 fi
69
70 ## make fake `id' if its missing, outputs 0 since if its missing we
71 ## are probably running on boot floppies and thus are root.
72 if (command -v id > /dev/null 2>&1) ; then 
73     true
74 else
75     id()
76     {
77     echo 0
78     }
79 fi
80
81 ## --version output
82 version()
83 {
84 echo \
85 "$PRG $VERSION
86 Written by Ethan Benson
87
88 Copyright (C) 2001, 2002, 2003 Ethan Benson
89 This is free software; see the source for copying conditions.  There is NO
90 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
91 }
92
93 ## --help output.
94 usage()
95 {
96 echo \
97 "Usage: $PRG [OPTION]...
98 Generate a working /etc/yaboot.conf.
99
100   -t, --chroot               set root directory $PRG should work from
101   -r, --root                 set root partition, Example: /dev/hda3
102                                default: determined from {chroot}/etc/fstab
103   -b, --boot                 set bootstrap partition, Example: /dev/hda2
104                                default: first type: Apple_Bootstrap partition
105       --kernel-args          add an append= line with specified arguments
106   -q, --quiet                don't ask any questions/confirmation
107       --noinstall            don't automatically run mkofboot
108   -h, --help                 display this help and exit
109   -V, --version              output version information and exit"
110 }
111
112 debug()
113 {
114     [ "$DEBUG" = 0 ] && return 0
115     $PRINTF 1>&2 "$PRG: DEBUG: $1"
116 }
117
118 confirm()
119 {
120     $PRINTF \
121 "yaboot is the Linux Loader for PowerPC.  $PRG sets up your system to boot directly
122 from your hard disk, without the need for a boot CD, floppy or a network boot.\n"
123 [ "$NOINSTALL" = 0 ] && $PRINTF "Install yaboot bootstrap on $BOOT to boot Linux from $ROOT? [Yes] "
124 [ "$NOINSTALL" = 1 ] && $PRINTF "Create simple ${CHROOT}${CONFIG} to boot Linux from $ROOT? [Yes] "
125     read ans
126     case "$ans" in
127         Y|y|Yes|yes|YES|"")
128         echo "Creating a simple ${CHROOT}${CONFIG}..."
129         return 0
130         ;;
131         *)
132         if [ "$NOINSTALL" = 0 ] ; then
133             $PRINTF "Create simple ${CHROOT}${CONFIG} without installing the bootstrap? [Yes] "
134             read ans
135             case "$ans" in
136                 Y|y|Yes|yes|YES|"")
137                 NOINSTALL=1
138                 echo 1>&2 "Creating a simple ${CHROOT}${CONFIG}..."
139                 return 0
140                 ;;
141                 *)
142                 echo "OK, quitting"
143                 return 1
144                 ;;
145             esac
146         else
147             echo "OK, quitting"
148             return 1
149         fi
150         ;;
151     esac
152 }
153
154 ## find out whether we have mac-fdisk or pdisk (they work the same)
155 ckmacfdisk()
156 {
157     if (command -v mac-fdisk > /dev/null 2>&1) ; then
158         FDISK=mac-fdisk
159     elif (command -v pdisk > /dev/null 2>&1) ; then
160         FDISK=pdisk
161     else
162         echo 1>&2 "$PRG: Unable to locate mac-fdisk"
163         return 1
164     fi
165
166     if [ ! -x `command -v $FDISK` 2> /dev/null ] ; then
167         echo 1>&2 "$PRG: `command -v $FDISK`: Permission denied"
168         return 1
169     fi
170     debug "mac-fdisk is: $FDISK\n"
171     return 0
172 }
173
174 ## find out if we have ddisk or fdisk (fdisk for dos labels) debian
175 ## uses both names
176 ckfdisk()
177 {
178     if (command -v ddisk > /dev/null 2>&1) ; then
179         FDISK=ddisk
180     elif (command -v fdisk > /dev/null 2>&1) ; then
181         FDISK=fdisk
182     else
183         echo 1>&2 "$PRG: Unable to locate fdisk"
184         return 1
185     fi
186
187     if [ ! -x `command -v $FDISK` 2> /dev/null ] ; then
188         echo 1>&2 "$PRG: `command -v $FDISK`: Permission denied"
189         return 1
190     fi
191     debug "fdisk is: $FDISK\n"
192     return 0
193 }
194
195 ## find bootstrap partition, supports IBM CHRP with msdos disklabels
196 findbootblock()
197 {
198     ## mac partition table magic == ER
199     if [ "$(dd if="$DISK" bs=2 count=1 2> /dev/null)" = ER ] ; then
200         ckmacfdisk || return 1
201         if [ "$FDISK" = pdisk ] ; then
202             ## handle braindamaged pdisk
203             debug "dealing with pdisk deficiency...\n"
204             BOOT="$(v=`$FDISK -l "$DISK" 2>/dev/null | grep '\<Apple_Bootstrap\>'` ; echo ${v%%:*})"
205             debug "BOOT before fixup: $BOOT\n"
206             if [ -n "$BOOT" ] ; then
207                 BOOT="${DISK}${BOOT}"
208             fi
209             debug "BOOT after fixup: $BOOT\n"
210         else
211             BOOT="$(v=`$FDISK -l "$DISK" 2>/dev/null | grep '\<Apple_Bootstrap\>'` ; echo ${v%%[ ]*})"
212             debug "BOOT=$BOOT\n"
213         fi
214         if [ -z "$BOOT" ] ; then
215             echo 1>&2 "$PRG: Unable to locate bootstrap partition on $DISK..."
216             echo 1>&2 "$PRG: You must create an 800K type: Apple_Bootstrap partition to make the disk bootable"
217             return 1
218         fi
219     else
220         ckfdisk || return 1
221         BOOT="$(v=`$FDISK -l "$DISK" 2>/dev/null | grep '\<PPC PReP Boot\>'` ; echo ${v%%[ ]*})"
222         debug "BOOT=$BOOT\n"
223         if [ -z "$BOOT" ] ; then
224             echo 1>&2 "$PRG: Unable to locate bootstrap partition on $DISK..."
225             echo 1>&2 "$PRG: You must create an 800K type: 0x41 PPC PReP Boot partition to make the disk bootable"
226             return 1
227         fi
228     fi
229     return 0
230 }
231
232 ## if readlink is missing use a kludge
233 if (command -v readlink > /dev/null 2>&1) ; then
234     true
235 else
236     readlink()
237     {
238         SYMTARGET="$(v=`ls -l "$2" 2>/dev/null` ; echo ${v##*> })"
239         if [ -n "$SYMTARGET" ] ; then
240             echo "$SYMTARGET"
241             return 0
242         else
243             return 1
244         fi
245     }
246 fi
247
248 ## we have to do some things differently with a retarded devfs name.
249 ckdevfs()
250 {
251     case "$1" in
252         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
253         return 0
254         ;;
255         *)
256         return 1
257         ;;
258     esac
259 }
260
261 cleanup()
262 {
263     if [ -n "$TMPCONF" ] ; then rm -f "$TMPCONF" ; fi
264     return 0
265 }
266
267 ##########
268 ## Main ##
269 ##########
270
271 if [ $# != 0 ] ; then
272     while true ; do
273         case "$1" in 
274             -V|--version)
275                 version
276                 exit 0
277                 ;;
278             -h|--help)
279                 usage
280                 exit 0
281                 ;;
282             -t|--chroot)
283                 if [ -n "$2" ] ; then
284                     CHROOT="$2"
285                     shift 2
286                 else
287                     echo 1>&2 "$PRG: option requires an argument $1"
288                     echo 1>&2 "Try \`$PRG --help' for more information."
289                     exit 1
290                 fi
291                 ;;
292             -b|--boot)
293                 if [ -n "$2" ] ; then
294                     BOOT="$2"
295                     shift 2
296                 else
297                     echo 1>&2 "$PRG: option requires an argument $1"
298                     echo 1>&2 "Try \`$PRG --help' for more information."
299                     exit 1
300                 fi
301                 ;;
302             -r|--root)
303                 if [ -n "$2" ] ; then
304                     ROOT="$2"
305                     shift 2
306                 else
307                     echo 1>&2 "$PRG: option requires an argument $1"
308                     echo 1>&2 "Try \`$PRG --help' for more information."
309                     exit 1
310                 fi
311                 ;;
312             --kernel-args)
313                 if [ -n "$2" ] ; then
314                     KERNARGS="$2"
315                     shift 2
316                 else
317                     echo 1>&2 "$PRG: option requires an argument $1"
318                     echo 1>&2 "Try \`$PRG --help' for more information."
319                     exit 1
320                 fi
321                 ;;
322             -q|--quiet)
323                 QUIET=1
324                 shift 1
325                 ;;
326             --noinstall)
327                 NOINSTALL=1
328                 shift 1
329                 ;;
330             --debug)
331                 DEBUG=1
332                 shift 1
333                 ;;
334             "")
335                 break
336                 ;;
337             *)
338                 echo 1>&2 "$PRG: unrecognized option \`$1'"
339                 echo 1>&2 "Try \`$PRG --help' for more information."
340                 exit 1
341                 ;;
342         esac
343     done
344 fi
345
346 if [ `id -u` != 0 ] ; then
347     echo 1>&2 "$PRG: You are not root, go away"
348     exit 1
349 fi
350
351 ## we need /proc because df does
352 if [ ! -f /proc/uptime ] ; then
353     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
354     exit 1
355 fi
356
357 ## check that chroot exists
358 if [ -d "$CHROOT" ] ; then
359     ## HACK: add trailing / to chroot, otherwise are paths later get b0rked.
360     case "$CHROOT" in
361         */)
362         true
363         ;;
364         *)
365         CHROOT="${CHROOT}/"
366         ;;
367     esac
368 elif [ ! -e "$CHROOT" ] ; then
369     echo 1>&2 "$PRG: $CHROOT: No such file or directory"
370     exit 1
371 elif [ ! -d "$CHROOT" ] ; then
372     echo 1>&2 "$PRG: $CHROOT: Not a directory"
373     exit 1
374 fi
375
376 ## make sure the chroot is an actual root filesystem
377 if [ ! -f "${CHROOT}etc/fstab" ] ; then
378     echo 1>&2 "$PRG: $CHROOT does not appear to be a valid root filesystem"
379     exit 1
380 fi
381
382 ## find / device
383 if [ -z "$ROOT" ] ; then
384     ## IMPORTANT! that last substitution is [<space><tab>] thats all ash will grok
385     ROOT="$(v=`grep '^[^#].*[[:blank:]]/[[:blank:]]' ${CHROOT}etc/fstab` ; echo ${v%%[  ]*})"
386     debug "ROOT=$ROOT\n"
387     if [ -z "$ROOT" ] ; then
388         echo 1>&2 "$PRG: Could not determine root partition, aborting..."
389         exit 1
390     fi
391 fi
392
393 ## make sure root device exists
394 if [ ! -e "$ROOT" ] ; then
395     echo 1>&2 "$PRG: $ROOT: No such file or directory"
396     exit 1
397 fi
398
399 ## find root disk.
400 if ckdevfs "$ROOT" ; then
401     DISK="${ROOT%/*}/disc"
402 else
403     DISK="${ROOT%%[0-9]*}"
404 fi
405 if [ -z "$DISK" ] ; then
406     echo 1>&2 "$PRG: Could not determine root disk, aborting..."
407     exit 1
408 fi
409
410 ## make sure main disk exists
411 if [ ! -e "$DISK" ] ; then
412     echo 1>&2 "$PRG: $DISK: No such file or directory"
413     exit 1
414 fi
415
416 ## find bootstrap partition
417 if [ -z "$BOOT" ] ; then
418     findbootblock || exit 1
419 fi
420
421 ## make sure bootstrap device exists
422 if [ ! -e "$BOOT" ] ; then
423     echo 1>&2 "$PRG: $BOOT: No such file or directory"
424     exit 1
425 fi
426
427 ## sanity check
428 for i in "$DISK" "$ROOT" "$BOOT" ; do
429     if [ ! -b "$i" ] ; then
430         echo 1>&2 "$PRG: $i: Not a block device"
431         exit 1
432     fi
433 done
434
435 ## unless --quiet ask permission to proceed
436 if [ "$QUIET" = 0 ] ; then
437     confirm || exit 2
438 fi
439
440 ## find the kernel in the usual places and (if not --quiet) ask the
441 ## user if we cannot find one.
442 if [ -f "${CHROOT}vmlinux" ] ; then
443     KERNEL="${CHROOT}vmlinux"
444     if [ -f "${CHROOT}initrd" ] ; then
445         INITRD="${CHROOT}initrd"
446     elif [ -f "${CHROOT}initrd.img" ] ; then
447         INITRD="${CHROOT}initrd.img"
448     elif [ -f "${CHROOT}initrd.gz" ] ; then
449         INITRD="${CHROOT}initrd.gz"
450     fi
451 elif [ -f "${CHROOT}boot/vmlinux" ] ; then
452     KERNEL="${CHROOT}boot/vmlinux"
453     if [ -f "${CHROOT}boot/initrd" ] ; then
454         INITRD="${CHROOT}boot/initrd"
455     elif [ -f "${CHROOT}boot/initrd.img" ] ; then
456         INITRD="${CHROOT}boot/initrd.img"
457     elif [ -f "${CHROOT}boot/initrd.gz" ] ; then
458         INITRD="${CHROOT}boot/initrd.gz"
459     fi
460 elif [ -f "${CHROOT}boot/vmlinux-`uname -r`" ] ; then
461     KERNEL="${CHROOT}boot/vmlinux-`uname -r`"
462     if [ -f "${CHROOT}boot/initrd-`uname -r`" ] ; then
463         INITRD="${CHROOT}boot/initrd-`uname -r`"
464     elif [ -f "${CHROOT}boot/initrd-`uname -r`.img" ] ; then
465         INITRD="${CHROOT}boot/initrd-`uname -r`.img"
466     elif [ -f "${CHROOT}boot/initrd-`uname -r`.gz" ] ; then
467         INITRD="${CHROOT}boot/initrd-`uname -r`.gz"
468     fi
469 elif [ -f "${CHROOT}vmlinux-`uname -r`" ] ; then
470     KERNEL="${CHROOT}vmlinux-`uname -r`"
471     if [ -f "${CHROOT}initrd-`uname -r`" ] ; then
472         INITRD="${CHROOT}initrd-`uname -r`"
473     elif [ -f "${CHROOT}initrd-`uname -r`.img" ] ; then
474         INITRD="${CHROOT}initrd-`uname -r`.img"
475     elif [ -f "${CHROOT}initrd-`uname -r`.gz" ] ; then
476         INITRD="${CHROOT}initrd-`uname -r`.gz"
477     fi
478 elif [ "$QUIET" = 0 ] ; then
479     echo 1>&2 "$PRG: Cannot find a kernel, please locate one"
480     while true ; do
481         $PRINTF 1>&2 "Enter path to a kernel image: "
482         read KERN
483         if [ -f "$KERN" ] ; then
484             KERNEL="$KERN"
485             break
486         elif [ ! -e "$KERN" ] ; then
487             echo 1>&2 "$PRG: $KERN: No such file or directory"
488         elif [ -d "$KERN" ] ; then
489             echo 1>&2 "$PRG: $KERN: Is a directory"
490         else
491             echo 1>&2 "$PRG: $KERN: Is not a regular file"
492         fi
493     done
494     while true ; do
495         $PRINTF 1>&2 "Enter path to an initrd image (hit Enter for none): "
496         read IRD
497         if [ -z "$IRD" ] ; then
498             break
499         fi
500         if [ -f "$IRD" ] ; then
501             INITRD="$IRD"
502             break
503         elif [ ! -e "$IRD" ] ; then
504             echo 1>&2 "$PRG: $IRD: No such file or directory"
505         elif [ -d "$IRD" ] ; then
506             echo 1>&2 "$PRG: $IRD: Is a directory"
507         else
508             echo 1>&2 "$PRG: $IRD: Is not a regular file"
509         fi
510     done
511 else
512     echo 1>&2 "$PRG: Cannot find a kernel, aborting..."
513     exit 1
514 fi
515
516 debug "KERNEL=$KERNEL\n"
517 debug "INITRD=$INITRD\n"
518
519 ## get partition number the kernel lives on, and the OF device= name
520 ## of the whole disk.
521 KERNDEV="$(v=`df "$KERNEL" 2> /dev/null | grep ^/dev/` ; echo ${v%%[ ]*})"
522 KERNDIR="$(v=`df "$KERNEL" 2> /dev/null | grep ^/dev/` ; echo ${v##*[ ]})"
523 LINKDEV="$(v=`df "${KERNEL%/*}/" 2>/dev/null | grep ^/dev/` ; echo ${v%%[ ]*})"
524 PARTITION="${KERNDEV##*[a-z]}"
525
526 if ckdevfs "$KERNDEV" ; then
527     KERNELDISK="${KERNDEV%/*}/disc"
528 else
529     KERNELDISK="${KERNDEV%%[0-9]*}"
530 fi
531
532 if [ -n "$INITRD" ] ; then
533     ## get partition number the initrd lives on, and the OF device= name
534     ## of the whole disk.
535     IRDDEV="$(v=`df "$INITRD" 2> /dev/null | grep ^/dev/` ; echo ${v%%[ ]*})"
536     IRDDIR="$(v=`df "$INITRD" 2> /dev/null | grep ^/dev/` ; echo ${v##*[ ]})"
537     IRDLINKDEV="$(v=`df "${INITRD%/*}/" 2>/dev/null | grep ^/dev/` ; echo ${v%%[ ]*})"
538     IRDPARTITION="${KERNDEV##*[a-z]}"
539
540     if ckdevfs "$IRDDEV" ; then
541         INITRDDISK="${IRDDEV%/*}/disc"
542     else
543         INITRDDISK="${IRDDEV%%[0-9]*}"
544     fi
545 fi
546
547 debug "KERNEL=$KERNEL\nKERNDEV=$KERNDEV\nKERNDIR=$KERNDIR\nLINKDEV=$LINKDEV\nPARTITION=$PARTITION\nKERNELDISK=$KERNELDISK\n"
548
549 if [ -n "$INITRD" ] ; then
550     debug "INITRD=$INITRD\nIRDDEV=$IRDDEV\nIRDDIR=$IRDDIR\nIRDLINKDEV=$IRDLINKDEV\nIRDPARTITION=$IRDPARTITION\nINITRDDISK=$INITRDDISK\n"
551 fi
552
553 ## sanity check
554 for i in "$KERNDEV" "$KERNDIR" "$LINKDEV" "$PARTITION" "$KERNELDISK" ; do
555     if [ -z "$i" ] ; then
556         echo 1>&2 "$PRG: Could not determine necessary information, aborting..."
557         echo 1>&2 "$PRG: Are you using chroot $PRG instead of $PRG --chroot ?"
558         exit 1
559     fi
560 done
561
562 if [ -n "$INITRD" ] ; then
563     ## sanity check
564     for i in "$IRDDEV" "$IRDDIR" "$IRDLINKDEV" "$IRDPARTITION" "$INITRDDISK" ; do
565         if [ -z "$i" ] ; then
566             echo 1>&2 "$PRG: Could not determine necessary information, aborting..."
567             echo 1>&2 "$PRG: Are you using chroot $PRG instead of $PRG --chroot ?"
568             exit 1
569         fi
570     done
571 fi
572
573 ## check for cross device symlink
574 if [ -L "$KERNEL" ] ; then
575     if [ "$KERNDEV" != "$LINKDEV" ] ; then
576         echo 1>&2 "$PRG: Warning: Cross device symlink $KERNEL, using it's target instead"
577         KERNEL="$(readlink -f "$KERNEL" 2>/dev/null)"
578         if [ ! -f "$KERNEL" ] ; then
579             echo 1>&2 "$PRG: Unable to canonicalize symlink's target.  Do not create cross device symlinks."
580             exit 1
581         fi
582     fi
583 fi
584
585 if [ -n "$INITRD" ] ; then
586     ## initrd must be on same device as kernel.
587     if [ "$IRDDEV" != "$KERNDEV" -o "$IRDPARTITION" != "$IRDPARTITION" -o "$INITRDDISK" != "$KERNELDISK" ] ; then
588         echo 1>&2 "$PRG: Initrd image must be on same device as kernel image."
589         exit 1
590     fi
591
592     ## check for cross device symlink
593     if [ -L "$INITRD" ] ; then
594         if [ "$IRDDEV" != "$IRDLINKDEV" ] ; then
595             echo 1>&2 "$PRG: Warning: Cross device symlink $INITRD, using it's target instead"
596             INITRD="$(readlink -f "$INITRD" 2>/dev/null)"
597             if [ ! -f "$INITRD" ] ; then
598                 echo 1>&2 "$PRG: Unable to canonicalize symlink's target.  Do not create cross device symlinks."
599                 exit 1
600             fi
601         fi
602     fi
603 fi
604
605 ## only powermacs appear to need device=
606 if (cat /proc/cpuinfo 2>/dev/null | grep -q pmac-generation 2> /dev/null) ; then
607     DEVICE="\ndevice=$($OFPATH $KERNELDISK)"
608     if [ $? != 0 ] ; then
609         echo 1>&2 "$PRG: Unable to determine OpenFirmware device name to $KERNELDISK, aborting..."
610         exit 1
611     fi
612 fi
613
614 ## if there is a separate /boot partition we must strip off the /boot
615 ## mountpoint or else yaboot will not find the kernel.
616 if [ "$KERNDIR" != "$CHROOT" ] ; then
617     IMAGE="${KERNEL##*$KERNDIR}"
618 else
619     IMAGE="$KERNEL"
620 fi
621
622 ## fix chrooted path
623 if [ "$CHROOT" != / ] ; then
624     IMAGE="${IMAGE##*$CHROOT}"
625 fi
626
627 ## fix relative path (caused by chroot path fix)
628 case "$IMAGE" in
629     /*)
630     true
631     ;;
632     *)
633     IMAGE="/${IMAGE}"
634     ;;
635 esac
636
637 if [ -n "$INITRD" ] ; then
638     ## if there is a separate /boot partition we must strip off the /boot
639     ## mountpoint or else yaboot will not find the kernel.
640     if [ "$IRDDIR" != "$CHROOT" ] ; then
641         INITRDIMG="${INITRD##*$IRDDIR}"
642     else
643         INITRDIMG="$INITRD"
644     fi
645
646     ## fix chrooted path
647     if [ "$CHROOT" != / ] ; then
648         INITRDIMG="${INITRDIMG##*$CHROOT}"
649     fi
650
651     ## fix relative path (caused by chroot path fix)
652     case "$INITRDIMG" in
653         /*)
654             true
655             ;;
656         *)
657             INITRDIMG="/${INITRDIMG}"
658             ;;
659     esac
660 fi
661
662 ## figure out if yaboot is installed in /usr/local or not
663 if [ -f /usr/local/lib/yaboot/yaboot ] ; then
664     INSTALL=/usr/local/lib/yaboot/yaboot
665 elif [ -f /usr/lib/yaboot/yaboot ] ; then
666     INSTALL=/usr/lib/yaboot/yaboot
667 else
668     echo 1>&2 "$PRG: yaboot is not installed correctly"
669     exit 1
670 fi
671
672 ## newworld powermacs need the ofboot first stage loader
673 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:})" = NewWorld ] ; then
674     if [ -f /usr/local/lib/yaboot/ofboot ] ; then
675         OFBOOT="\nmagicboot=/usr/local/lib/yaboot/ofboot"
676     elif [ -f /usr/lib/yaboot/ofboot ] ; then
677         OFBOOT="\nmagicboot=/usr/lib/yaboot/ofboot"
678     else
679         echo 1>&2 "$PRG: yaboot is not installed correctly"
680         exit 1
681     fi
682 fi    
683
684 ## check for properly (read debian) packaged yaboot.
685 if [ -d ${CHROOT}usr/share/doc/yaboot/examples ] ; then
686     HEADER="## see also: /usr/share/doc/yaboot/examples for example configurations.\n"
687 fi
688
689 ## setup append line
690 if [ -n "$KERNARGS" ] ; then
691     APPEND="\tappend=\"${KERNARGS}\"\n"
692 fi
693
694 ## avoid user confusion when they boot an installer with video=ofonly
695 ## (usually via a install-safe label) and then reboot and have the box
696 ## not boot properly again.
697 if [ -z "$APPEND" ] ; then
698     if (grep -q '\<video=ofonly\>' /proc/cmdline 2> /dev/null) ; then
699         APPEND="\tappend=\"video=ofonly\"\n"
700     fi
701 fi
702
703 ## generate initrd= lines
704 if [ -n "$INITRDIMG" ] ; then
705     INITRDIMGS="\tinitrd=$INITRDIMG\n\tinitrd-size=8192\n"
706 fi
707
708 ## generate global section of yaboot.conf
709 GLOBAL="## yaboot.conf generated by $PRG $VERSION
710 ##
711 ## run: \"man yaboot.conf\" for details. Do not make changes until you have!!
712 ${HEADER}##
713 ## For a dual-boot menu, add one or more of: 
714 ## bsd=/dev/hdaX, macos=/dev/hdaY, macosx=/dev/hdaZ\n
715 boot=${BOOT}${DEVICE:-}
716 partition=$PARTITION
717 root=$ROOT
718 timeout=30
719 install=${INSTALL}${OFBOOT:-}\n"
720
721 ## generate image= section
722 IMAGES="
723 image=$IMAGE
724 \tlabel=Linux
725 \tread-only\n${APPEND:-}${INITRDIMGS:-}"
726
727 ## safely create a tmp file then move it into place after we are sure
728 ## it was written.
729 TMPCONF=`mktemp -q "${CHROOT}${CONFIG}.XXXXXX"`
730 if [ $? != 0 ] ; then
731     echo 1>&2 "$PRG: Unable to write to ${CHROOT}${CONFIG%/*}"
732     exit 1
733 fi
734
735 $PRINTF "${GLOBAL}${IMAGES}" > "$TMPCONF"
736 if [ $? != 0 ] ; then
737     echo 1>&2 "$PRG: Unable to write temporary file ${TMPCONF}, aborting..."
738     exit 1
739 fi
740
741 ## rotate backups of /etc/yaboot.conf, 3 backups are kept
742 if [ -f "${CHROOT}${CONFIG}.old" ] ; then
743     for i in 1 0 ; do
744         if [ -f "${CHROOT}${CONFIG}.old.${i}" ] ; then
745             mv -f "${CHROOT}${CONFIG}.old.$i" "${CHROOT}${CONFIG}.old.$(($i + 1))"
746             if [ $? != 0 ] ; then
747                 echo 1>&2 "$PRG: Unable to make backup of existing ${CHROOT}${CONFIG}.old.$i, aborting..."
748                 exit 1
749             fi
750         fi
751     done
752
753     mv -f "${CHROOT}${CONFIG}.old" "${CHROOT}${CONFIG}.old.0"
754     if [ $? != 0 ] ; then
755         echo 1>&2 "$PRG: Unable to make backup of existing ${CHROOT}${CONFIG}.old, aborting..."
756         exit 1
757     fi
758 fi
759
760 ## backup /etc/yaboot.conf
761 if [ -f "${CHROOT}${CONFIG}" ] ; then
762     mv -f "${CHROOT}${CONFIG}" "${CHROOT}${CONFIG}.old"
763     if [ $? != 0 ] ; then
764         echo 1>&2 "$PRG: Unable to make backup of existing ${CHROOT}${CONFIG}, aborting..."
765         exit 1
766     fi
767 fi
768
769 ## move new config into place
770 mv -f "${TMPCONF}" "${CHROOT}${CONFIG}"
771 if [ $? != 0 ] ; then
772     echo "$PRG: Unable to write file ${CHROOT}${CONFIG}"
773     exit 1
774 else
775     ## nothing sensitive in generated config, comply with debian policy
776     chmod 644 "${CHROOT}${CONFIG}"
777 fi
778
779 ## tell mkofboot where to find the config file if necessary
780 if [ "${CHROOT}${CONFIG}" != /etc/yaboot.conf ] ; then
781     YBINARGS="-C ${CHROOT}${CONFIG}"
782 fi
783
784 ## run mkofboot to install the bootstrap, unless --noinstall
785 if [ "$NOINSTALL" = 0 ] ; then
786     if (command -v mkofboot 2>&1 > /dev/null) ; then
787         [ "$QUIET" = 0 ] && echo "Running mkofboot to make the disk bootable..."
788         mkofboot -f $YBINARGS || exit 1
789         [ "$QUIET" = 0 ] && echo "Done"
790     else
791         echo 1>&2 "$PRG: yaboot is not installed correctly, not running mkofboot"
792         exit 1
793     fi
794 fi
795
796 exit 0